package serversettings

import (
	"strconv"

	"git.umbach.dev/app-idea/rest-api/modules/database"
	log "github.com/sirupsen/logrus"
)

type ServerSettings struct {
	ExpiredTime int64
}

var Settings ServerSettings

func LoadServerSettings() {
	log.Debug("load server settings from db")

	rows, err := database.DB.Raw("SELECT name, value FROM server_settings").Rows()

	if err != nil {
		log.Fatal("failed to load server settings:", err)
	}

	defer rows.Close()

	var (
		name  string
		value string
	)

	for rows.Next() {
		rows.Scan(&name, &value)

		log.Debugln("server setting:", name, value)

		switch name {
		case "expired_time":
			n, err := strconv.ParseInt(value, 0, 64)

			if err != nil {
				log.Fatalln("failed to parse server setting: expired_time", err)
			}

			Settings.ExpiredTime = n
		}
	}
}
